@Echo off

REM Most arguments passed to us via the environment as they contain spaces...

if not defined SERVER goto NotSet
if not defined BASE_ARGS goto NotSet
if not defined TEST_CLIENT_BASE_ARGS goto NotSet
if not defined NUM_CONNECTIONS set NUM_CONNECTIONS=100
if not defined NUM_MESSAGES set NUM_MESSAGES=100

goto DisplayDebug

:NotSet
Echo One or more of the following variables is not set:
Echo -
Echo SERVER=%SERVER%
Echo BASE_ARGS=%BASE_ARGS%
Echo TEST_CLIENT_BASE_ARGS=%TEST_CLIENT_BASE_ARGS%
Echo -
Echo Please ensure they are all set in the environment before calling.
Exit /b 1

:DisplayDebug
if not defined JETBYTE_DEBUG_BUILD_SCRIPTS goto NoDebug
Echo Script debug information - RunTests.bat
Echo - 
Echo Required: SERVER=%SERVER%
Echo Required: BASE_ARGS=%BASE_ARGS%
Echo Optional: BASE_TEST_NAME=%BASE_TEST_NAME%
Echo Optional: NUM_CONNECTIONS=%NUM_CONNECTIONS%
Echo Optional: NUM_MESSAGES=%NUM_MESSAGES%
Echo -

:NoDebug

:RunTests

set SERVER_ARGS=%BASE_ARGS%
set TEST_CLIENT="..\..\Test\WebSocketEchoServerTest.exe"

set TEST_NAME=%BASE_TEST_NAME% - HyBi server
set TEST_CLIENT_ARGS=-port 5050 %TEST_CLIENT_BASE_ARGS% -messageSize 512

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% - HyBi server (message accumulating)
set TEST_CLIENT_ARGS=-port 5051 %TEST_CLIENT_BASE_ARGS% -messageSize 4096

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% - HyBi server (message accumulating #2)
set TEST_CLIENT_ARGS=-port 5052 %TEST_CLIENT_BASE_ARGS% -messageSize 4096

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% - HyBi server (fragment echoing)
set TEST_CLIENT_ARGS=-port 5053 %TEST_CLIENT_BASE_ARGS% -messageSize 4096

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

set TEST_NAME=%BASE_TEST_NAME% - HyBi server (fragment echoing #2)
set TEST_CLIENT_ARGS=-port 5054 %TEST_CLIENT_BASE_ARGS% -messageSize 4096

REM most arguments passed to RunTest.bat via the environment as they contain spaces...

call ..\..\Test\RunTest.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%
