@Echo off

cd ..\Test

setlocal

REM Uncomment to enable some debug info on what variables are set and why things
REM are happening (or not happening)
REM set JETBYTE_DEBUG_BUILD_SCRIPTS=YES

set OUT_DIR=%1%

if defined OUT_DIR goto RunTests

Echo Usage: TestServer.bat $(OutDir)
Echo OUT_DIR=%OUT_DIR%
Exit /b 1

:RunTests

set OUT_DIR=..\%OUT_DIR%

REM comment this out to NOT run the memory usage test
REM set MEMORY_LIMIT=600000000

REM uncomment this out to run the lock inversion detector
set SERVER_USE_LID=TRUE
REM uncomment this out to run the full deadlock detector
REM set SERVER_USE_LIA=TRUE

REM uncomment this to run the lock inversion detector on the client side of the test
set CLIENT_USE_LID=TRUE
REM uncomment this to run the full deadlock detector on the client side of the test
REM set CLIENT_USE_LIA=TRUE
REM set LIA_CLIENT_ARGS=-symbols L:\Symbols\SocketServerBuildTools

set SERVER=SecureWebSocketServer.exe
set BASE_ARGS=-certificatePath ..\..\Test\ -port 5050 -listenBacklog 100

REM arguments passed to RunTests.bat via the environment as they contain spaces...


set NUM_CONNECTIONS=10
set NUM_MESSAGES=10
REM set CLIENT_READ_TIMEOUT=10000

set TEST_SCRIPT=..\Test\RunTestsForClientSettings.bat

call ..\..\Test\RunInstrumentedTests.bat
if ERRORLEVEL 1 Exit /b %ERRORLEVEL%

Echo Done
