#pragma once
#ifndef SERVER_COMMON_BUFFER_HANDLE_ALLOCATOR_INCLUDED__
#define SERVER_COMMON_BUFFER_HANDLE_ALLOCATOR_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: BufferHandleAllocator.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2009 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/IOTools/IMonitorBufferAllocation.h"
#include "JetByteTools/IOTools/BufferHandleAllocator.h"

///////////////////////////////////////////////////////////////////////////////
// CBufferHandleAllocator
///////////////////////////////////////////////////////////////////////////////

class CBufferHandleAllocator:
   public JetByteTools::IO::CBufferHandleAllocator,
   private JetByteTools::IO::IMonitorBufferAllocation
{
   public :

      CBufferHandleAllocator(
         BufferCount maxFreeBuffers,
         JetByteTools::IO::IAllocateBuffers &bufferAllocator,
         bool log = true);

      CBufferHandleAllocator(
         const CBufferHandleAllocator &rhs) = delete;

      ~CBufferHandleAllocator() override;

      CBufferHandleAllocator &operator=(
         const CBufferHandleAllocator &rhs) = delete;

   private :

      /// Implement IMonitorBufferAllocation

      void OnBufferCreated() override;

      void OnBufferAllocated(
         JetByteTools::Core::IIndexedOpaqueUserData &userData) override;

      void OnBufferAllocationContention() override;

      void OnBufferReleaseContention() override;

      void OnBufferReleased(
         JetByteTools::Core::IIndexedOpaqueUserData &userData) override;

      void OnBufferDestroyed() override;

      const bool m_log;
};

#endif // SERVER_COMMON_BUFFER_HANDLE_ALLOCATOR_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: BufferHandleAllocator.h
///////////////////////////////////////////////////////////////////////////////
