#pragma once
#ifndef SERVER_COMMON_SIMPLE_SERVICE_STARTUP_EVENT_HANDLER_INCLUDED__
#define SERVER_COMMON_SIMPLE_SERVICE_STARTUP_EVENT_HANDLER_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: SimpleServiceStartupEventHandler.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2010 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/CoreTools/tstring.h"

#include "JetByteTools/Win32Tools/ManualResetEvent.h"
#include "JetByteTools/Win32Tools/SecurityDescriptorAllowAll.h"
#include "JetByteTools/Win32Tools/SecurityAttributes.h"

///////////////////////////////////////////////////////////////////////////////
// CSimpleServiceStartupEventHandler
///////////////////////////////////////////////////////////////////////////////

class CSimpleServiceStartupEventHandler
{
   public :

      CSimpleServiceStartupEventHandler();

      explicit CSimpleServiceStartupEventHandler(
         const JetByteTools::Core::_tstring &startupEventName);

      CSimpleServiceStartupEventHandler(
         const CSimpleServiceStartupEventHandler &rhs) = delete;

      CSimpleServiceStartupEventHandler &operator=(
         const CSimpleServiceStartupEventHandler &rhs) = delete;

      void StartupComplete();

   private :

      JetByteTools::Win32::CSecurityDescriptorAllowAll m_sd;

      JetByteTools::Win32::CSecurityAttributes m_sa;

      JetByteTools::Win32::CManualResetEvent m_serverStartedEvent;

      bool m_startupComplete;
};

#endif // SERVER_COMMON_SIMPLE_SERVICE_STARTUP_EVENT_HANDLER_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: SimpleServiceStartupEventHandler.h
///////////////////////////////////////////////////////////////////////////////
